from BBaum import BTree
import numpy as np
import random

class WrongInputVariables(Exception):
    pass


class BTree_Creator:
    def __init__(self, height, maxValueInTree,
                 valuesCountInOneNode, isInsertingTree):
        self.height = height
        # values from 0 to maxValueInTree
        self.maxValueInTree = maxValueInTree
        # maxValuesInOneNode is the M value from the lecture
        self.valuesCountInOneNode = valuesCountInOneNode
        # because we dont want to build trivial trees
        # we disguingish between imserting and deleting trees
        self.isInsertingTree = isInsertingTree
        # while correction we dont want an endless loop
        self.maxInterationsCorrection = 5
        # to ensure that not only NOT trival inserting or deleting exist
        self.madeOneNodeFull = False
        self.madeOneNodeHalfFull = False

        # just for safetiness check if tree is 100% correct
        treeIncorrect = True
        while self.maxInterationsCorrection > 0 and treeIncorrect:
            self.myBBaum = BTree(valuesCountInOneNode)
            print("creating tree...")
            self.buildTree([(0, None, 0, maxValueInTree, 0)])
            print("done.")
            print("checking if tree is correct...")
            rootNode = next((x for x in self.myBBaum.nodeArray
                             if x.previousNode == None), None)
            treeIncorrect = self.treeIncorrect(rootNode)
            if not treeIncorrect:
                print("done.")
            self.maxInterationsCorrection -= 1

    # ---------------- check if tree is correct ----------------
    def treeIncorrect(self, parentNode):
        if parentNode.nextNodes == [None] * (self.valuesCountInOneNode + 1):
            return False
        # one of the children is not None
        isIncorrect = False
        for i, child in enumerate(parentNode.nextNodes):
            if i < len(parentNode.values):
                # because last one has to be compered differently
                if child != None:
                    # all values has to be smaller
                    if child.values[-1] >= parentNode.values[i]:
                        # last is bigger -> btree property hurted
                        print("Tree is incorrect.")
                        print("at nodeNumber:", i, "parentValues:",
                              parentNode.values, "childValues:",
                              child.values)
                        return True
                    else:
                        return isIncorrect or self.treeIncorrect(child)
            else:
                # now check if its bigger...
                if child != None:
                    if child.values[0] < parentNode.values[i - 1]:
                        # last is smaller -> btree property hurted
                        print("Tree is incorrect.")
                        print("at nodeNumber:", i, "parentValues:",
                              parentNode.values, "childValues:",
                              child.values)
                        return True
                    else:
                        return isIncorrect or self.treeIncorrect(child)

        return isIncorrect

    # build recusivly use level order because of naming the nodes
    # min and max value determine how which values will be coveres and this
    # node and its decand
    # nodename is a number
    # parentNode for connecting
    def buildTree(self, stackForRecursion):

        # here is somehow a bug maybe not everything get loaded
        # if stack is NOT empty
        if len(stackForRecursion) == 0:
            return

        (nodeName, parentNode, minValue, maxValue,
         currentHeight) = stackForRecursion.pop(0)

        if currentHeight > self.height:
            return

        isLeftChild = True

        if parentNode != None:
            isLeftChild = maxValue <= parentNode

        values = self.createValueArray(minValue, maxValue,
                                       isLeftChild, currentHeight)

        if values == None:
            return

        # print("Nodename:",nodeName, self.getNodeName(nodeName))
        self.myBBaum.add_node(self.getNodeName(nodeName), values)

        if parentNode != None:
            thisNodeIsChildNumber = (nodeName % (self.valuesCountInOneNode + 1))
            if thisNodeIsChildNumber == 0:
                thisNodeIsChildNumber = self.valuesCountInOneNode + 1
            # print("add edge from:",parentNode, "to", nodeName,
            #       "N:",thisNodeIsChildNumber)

            self.myBBaum.add_edge(self.getNodeName(parentNode),
                                  self.getNodeName(nodeName),
                                  thisNodeIsChildNumber)

        # :) calculate the nodeposition in btree
        nextNodeName = nodeName * (self.valuesCountInOneNode + 1)

        borders = values.copy()
        borders.append(maxValue)
        borders.insert(0, minValue)

        for i in range(1, len(borders)):
            previousIntervallBorder = borders[i - 1]
            nextIntervallBorder = borders[i]
            nextNodeName += 1
            # print("added next node:",nextNodeName, self.getNodeName(nextNodeName))
            nodeTupel = (nextNodeName, nodeName,
                         previousIntervallBorder,
                         nextIntervallBorder, currentHeight + 1)

            stackForRecursion.append(nodeTupel)

        # rekursiv call
        for _ in range(0, self.valuesCountInOneNode + 1):
            self.buildTree(stackForRecursion)

    # ---------------- create values in one node ----------------
    def createValueArray(self, minVal, maxVal, isLeftChild,
                         currentHeight):

        distance = maxVal - minVal

        if distance == 1:
            if isLeftChild:
                return [minVal] * self.valuesCountInOneNode
            else:
                return [maxVal] * self.valuesCountInOneNode
        if distance <= 0:
            return None

        stepSize = distance // (self.valuesCountInOneNode)

        values = []
        curMin = minVal + 1
        curMax = curMin - 1 + stepSize

        fillSizeOfNodes = int(np.random
                              .random_integers(low=self.valuesCountInOneNode // 2 \
                                                   + self.valuesCountInOneNode % 2,
                                               high=self.valuesCountInOneNode))
        if currentHeight == self.height:
            # we want neither one leaf full nor one leaf half full
            if self.isInsertingTree:
                if not self.madeOneNodeFull:
                    # no leaf node has been made full yet
                    fillSizeOfNodes = self.valuesCountInOneNode
                    self.madeOneNodeFull = True
            else:
                if not self.madeOneNodeHalfFull:
                    # make leafs half empty
                    fillSizeOfNodes = self.valuesCountInOneNode // 2 \
                                      + self.valuesCountInOneNode % 2
                    self.madeOneNodeHalfFull = True

        for i in range(0, fillSizeOfNodes):
            low = curMin + stepSize // 4
            high = curMax - stepSize // 4
            if low >= high:
                low = curMin
                high = curMax
                if low >= high:
                    raise WrongInputVariables(
                        "Die range für diesen Unterknoten besteht nur aus einer Zahl. Wir möchten diese Bäume vermeiden.\n 1. run script again\n 2. Bitte starte Script erneut mit anderen Height- und/oder maxValue-Werten.")

            newValue = int(np.random
                           .random_integers(low=low,
                                            high=high))
            if i > 0 and newValue < values[i - 1]:
                # now every value is sorted!
                newValue = values[i - 1]

            values.append(newValue)

            curMin = curMax
            curMax = curMin + stepSize

        return values

    # insert a number and it return the letter combination
    # for ex: 2=B,3=C,27=AA
    def getNodeName(self, num):
        numOfA_s = num // 26
        nodeName = ''
        for _ in range(0, numOfA_s):
            nodeName += 'A'

        return nodeName + str(chr((num % 26) + ord('A')))